
var SystemSettings = {
    
}


/* A 'base class' intended for use by lens model view classes
Uses protypal inheritance
Javascript isn't really object oriented, but this at serves the purpose */
/* useage example*/
/*
function MyViewModel() {

self = this;
self.oh = function () { alert('oh') };
}

MyViewModel.prototype.Create=function () {
MyViewModel.prototype = new BaseViewModel;
MyViewModel.prototype.constructor = BaseViewModel;
return new MyViewModel();
}

function testmyviewmodel() {
var self = this;
    
var mymodel = MyViewModel.prototype.Create();// CreateMyViewModel();
mymodel.oh();
mymodel.hello('hello');
}

*/


var urlBase;
var jsonDataType;
function BaseViewModel() {
    try {
        var self = this;
        self.sayhello = function (mssg) {
            alert(mssg);
        }

        var $idown;  // Keep it outside of the function, so it's initialized once.
        self.downloadURL = function (url) {
            if ($idown) {
                $idown.attr('src', url);
            } else {
                $idown = $('<iframe>', { id: 'idown', src: url }).hide().appendTo('body');
            }
        };
        self.ErrorStatus = ko.observable(' ');
        var deployToServer = true; //set this true to deploy to server
        self.UrlBase = ko.observable();
        self.MJSONDataType = ko.observable();
        if (deployToServer) {
			self.UrlBase('webapi/api/');
            self.MJSONDataType('json');
        }
        else {
            self.UrlBase('http://lenswebapi/api/');
            self.MJSONDataType('jsonp');
        }
        urlBase = self.UrlBase();
        jsonDataType = self.MJSONDataType();

        
        
    }
    catch (e) {
        self.BaseErrorHandler('Error constructing BaseViewModel', e);
    }

}

/**
* converts the input integer value to a bit array cast as a string, padded to a length 10 with 0's.
*
* @method GetBitArray
* @param {integer} varInt.   
* @return {string} of the bit array.  padded to length 10 with 0's.
*/
BaseViewModel.prototype.GetBitArray = function (varInt) {
    var str = (varInt).toString(2);
    str = str.split('').reverse().join('');
    while (str.length < 10) {
        str += '0';
    }
    return str;
}

BaseViewModel.prototype.BaseErrorHandler = function (p1, p2) {//mssg, e) {

    try {
        var self = this;
        var mssg;
        var e;
        if ((p1 != undefined) && (p2 != undefined)) {
            e = p2;
            mssg = p1;
        }
        else if (p1 != undefined) {
            e = p1;
            mssg = '';
        }
        else {
            return;
        }

        var entry = 'Error ' + mssg + ' ' + e.message + ' at ' + e.fileName + ' line ' + e.lineNumber;

        alert(entry);
    }
    catch (e) {
    }

}

//BaseViewModel.prototype.UserName = ko.observable();

BaseViewModel.prototype.hello = function (mssg) {
    alert(mssg);
}

BaseViewModel.prototype.parseBool= function(value) {
    return (typeof value === "undefined") ?
           false :
    // trim using jQuery.trim()'s source
           value.replace(/^s+|s+$/g, "").toLowerCase() === "true";
}

BaseViewModel.prototype.setCookie = function (c_name, value, exdays) {
    var exdate = new Date();
    exdate.setDate(exdate.getDate() + exdays);
    var c_value = escape(value) + ((exdays == null) ? "" : "; expires=" + exdate.toUTCString());
    document.cookie = c_name + "=" + c_value;
}
BaseViewModel.prototype.GetQueryParameter = function (paramName) {
    return $.QueryString["param"];
};


/* cookie functions thanks to W3Schools*/
BaseViewModel.prototype.getCookie = function (c_name) {
    var c_value = document.cookie;
    var c_start = c_value.indexOf(" " + c_name + "=");
    if (c_start == -1) {
        c_start = c_value.indexOf(c_name + "=");
    }
    if (c_start == -1) {
        c_value = null;
    }
    else {
        c_start = c_value.indexOf("=", c_start) + 1;
        var c_end = c_value.indexOf(";", c_start);
        if (c_end == -1) {
            c_end = c_value.length;
        }
        c_value = unescape(c_value.substring(c_start, c_end));
    }
    return c_value;
}

BaseViewModel.prototype.cookieExists = function checkCookie(cookieName) {
    var val = BaseViewModel.prototype.getCookie(cookieName);
    if (val != null && val != "") {
        return true
    }
    else {
        return false;
    }
}

BaseViewModel.prototype.deleteCookie = function (c_name) {
    try {
        document.cookie = encodeURIComponent(c_name) + "=deleted; expires=" + new Date(0).toUTCString();
    }
    catch (e) {
        BaseViewModel.prototype.OnError('Error in delete cookie(' + c_name + ')', e);
    }
}

BaseViewModel.prototype.OnError = function (mssg, e) {
    if (mssg != undefined) {
        alert(mssg + " " + e)
    }
    else {
        alert(e);
    }
}

BaseViewModel.prototype.getLastScreenRequested = function () {
    try {
        var screen = "";
        if (BaseViewModel.prototype.cookieExists('lastscreenrequested')) {
            screen = BaseViewModel.prototype.getCookie('lastscreenrequested');
        }
        return screen;
    }
    catch (e) {
        BaseViewModel.prototype.OnError('error getting lastscreenrequested from cookie ' + e);
    }
}

BaseViewModel.prototype.setLastScreenRequested = function (screen) {
    try {
		BaseViewModel.prototype.setCookie('lastscreenrequested', screen, 1);
    }
    catch (e) {
        BaseViewModel.prototype.OnError('error getting username from cookie ' + e);
    }
}

BaseViewModel.prototype.getUserName = function () {
    try {
        var userName = "";
        if (BaseViewModel.prototype.cookieExists('authentication')) {
            var authinfo = BaseViewModel.prototype.getCookie('authentication');
            var arrayinfo = authinfo.split(',');
            userName = arrayinfo[0];
        }

        return userName;
    }
    catch (e) {
        BaseViewModel.prototype.OnError('error getting username from cookie ' + e);
    }
}

BaseViewModel.prototype.getAuthenticationLevel = function () {
    try {
        var authenticationLevel = "";
        if (BaseViewModel.prototype.cookieExists('authentication')) {
            var authinfo = BaseViewModel.prototype.getCookie('authentication');
            var arrayinfo = authinfo.split(',');
            authenticationLevel = arrayinfo[1];
        }

        return authenticationLevel;
    }
    catch (e) {
        BaseViewModel.prototype.OnError('error getting authenticationlevel from cookie ' + e);
    }
}

BaseViewModel.prototype.getHostName = function () {
    try {
        var hostName = "";
        if (BaseViewModel.prototype.cookieExists('authentication')) {
            var authinfo = BaseViewModel.prototype.getCookie('authentication');
            var arrayinfo = authinfo.split(',');
            hostName = arrayinfo[2];
            if (hostName != null && hostName.length > 8) {
				// capture the last 8 chars of host name for device entry
                hostName = hostName.slice(hostName.length - 8);
                //hostName = hostName.substr(0, 8);
            }
        }

        return hostName;
    }
    catch (e) {
        BaseViewModel.prototype.OnError('error getting hostname from cookie ' + e);
    }
}

BaseViewModel.prototype.IsFilterAssigned = function (param) {
    try {
        if ((param == undefined) || (param == null)) { //the undefined is usually the best indicator unless was deliberately set to null
            return false;
        }
        else if (param.toString().indexOf('Pick Date') > -1) {
            return false;
        }
        else if (param.toString().indexOf('Pick Start Date') > -1) {
            return false;
        }
        else if (param.toString().indexOf('Pick End Date') > -1) {
            return false;
        }
        else {
            return (param.toString().indexOf('Select') === -1);
        }
    }
    catch (e) {
        BaseViewModel.prototype.BaseErrorHandler(e);
        return false;
    }
}

BaseViewModel.prototype.GetValidFilterValue = function (param) {
    try {
        if (!BaseViewModel.prototype.IsFilterAssigned(param)) {
            return undefined;
        }
        else {
            return param;
        }
    }
    catch (e) {
        BaseViewModel.prototype.BaseErrorHandler(e);
    }

}

String.prototype.endsWith = function (suffix) {
    return this.indexOf(suffix, this.length - suffix.length) !== -1;
};

BaseViewModel.prototype.GetValidTimeFilterValue = function (param) {
    try {
        if (!BaseViewModel.prototype.IsFilterAssigned(param)) {
            return undefined;
        }
        else {
            return param.toString().replace(/_/g, '');
        }
    }
    catch (e) {
        BaseViewModel.prototype.BaseErrorHandler(e);
    }

}

BaseViewModel.prototype.LoadConfigurationSettings = function (oncomplete) {
    var self = this;
    var murl = self.UrlBase() + "eventlist";

    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            data: { MethodName: 'GetApplicationConfigurationAll', Parameters: ko.toJSON({}) },
            success: function (jsondata) {
                var settings = {};
                for (var i = 0; i < jsondata.length; i++) {
                    if (jsondata[i] != undefined) {
                        if (jsondata[i].system_cfg_id != undefined) {
                            settings[jsondata[i].system_cfg_id.toString()] = jsondata[i].system_cfg_val;
                        }
                    }
                };
                if (oncomplete != undefined) {
                    oncomplete(settings);
                }
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetApplicationConfigurationAll failed with error: " + jqxhr.status + ' ' + jqxhr.statusText);
            }
        });
    }
    catch (error) {
        self.BaseErrorHandler('SystemSettings.ReadInSettings Error reading in settings ', error);
    }
}
var modaldlgid = 1;
BaseViewModel.prototype.ShowIGDialog = function (link, className, height, width, headerText, onstatechange) {
    try {
        var self = this;
        modaldlgid++;
        var div = document.createElement("div");
        var id = "ModalDialg" + modaldlgid;
        div.id = id;
        var iframe = document.createElement('iframe');
        iframe.className = className;

        iframe.setAttribute("src", link);
        div.appendChild(iframe);
        document.body.appendChild(div);
        $("#" + id).igDialog({
            state: "open",
            headerText: headerText,
            height: height,
            width: width,
            stateChanged: onstatechange != undefined ? onstatechange : function (ui, evt) {
                if (evt.action == 'close') {
                    var div = document.getElementById(ui.target.id);
                    div.parentNode.removeChild(div);
                }
            }
        });
        return "#" + id;
    }
    catch (e) {
        self.BaseErrorHandler("Error in self.ShowIGDialog", e);
    }
}


/*Get distinct array of all groups.  Includes unconfigured groups.*/


BaseViewModel.prototype.DeleteChannelConfig = function (id, oncomplete) {
    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    try {
        $.ajax({
            dataType: self.MJSONDataType(), //self.MJSONDataType(), //"json",
            url: murl,
            data: { MethodName: 'DeleteChannelConfiguration', Parameters: ko.toJSON({ ch_grp_hdr_id: id })
            },
            success: function (jsondata) {
                oncomplete(jsondata[0]);
            }
        });
    }
    catch (error) {
        BaseViewModel.prototype(error);
    }
}


BaseViewModel.prototype.DeleteConfig = function (olm_cfg_id, oncomplete) {
    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    try {
        $.ajax({
            dataType: self.MJSONDataType(), //self.MJSONDataType(), //"json",
            url: murl,
            data: { MethodName: 'DeleteConfiguration', Parameters: ko.toJSON({ OlmCfgID: olm_cfg_id })
            },
            success: function (jsondata) {
                oncomplete(jsondata[0]);
            }
        });
    }
    catch (error) {
        alert(error);
    }
}

BaseViewModel.prototype.AddConfig = function (cfg, oncomplete) {
    try {
        var self = this;
        var murl = self.UrlBase() + 'olmconfig';

        try {
            $.ajax({
                dataType: self.MJSONDataType(),
                url: murl,
                data: { MethodName: 'AddConfiguration',
                    Parameters: ko.toJSON(
                {
                    OlmCfgID: cfg.olm_cfg_id,
                    entry_by_name: cfg.entry_by_name,
                    comm_id: cfg.comm_id,
                    cfg_grp_id: cfg.cfg_grp_id,
                    base_hdr_id: cfg.base_hdr_id,
                    ch_grp_hdr_id: cfg.ch_grp_hdr_id,
                    ev_cfg_hdr_id: cfg.ev_cfg_hdr_id,
                    vrt_chs_hdr_id: cfg.vrt_chs_hdr_id,
                    cfg_desc: cfg.cfg_desc
                }
            )
                },
                success: function (jsondata) {
                    oncomplete(jsondata[0]);
                },
                error: function (jqxhr, textStatus) {
                    alert("Ajax request AddConfig failed with error: " + jqxhr.statusText);
                }
            });
        }
        catch (error) {
            alert(error);
        }


    }
    catch (e) {
        OnError("Error in UpdateConfig ", e);
    }
}

BaseViewModel.prototype.UpdateChannelConfig = function (cfg, oncomplete) {
    try {
        var self = this;
        var murl = self.UrlBase() + 'olmconfig';

        try {
            $.ajax({
                dataType: self.MJSONDataType(),
                url: murl,
                data: { MethodName: 'UpdateChannelConfiguration',
                    Parameters: ko.toJSON(
                {
                    ch_grp_hdr_id: cfg.ch_grp_hdr_id,
                    entry_by_name: cfg.entry_by_name,
                    ch_grp_hdr_desc: cfg.ch_grp_hdr_desc,
                    ch1_name: cfg.ch1_desc,
                    ch2_name: cfg.ch2_desc,
                    ch3_name: cfg.ch3_desc,
                    ch4_name: cfg.ch4_desc,
                    ch5_name: cfg.ch5_desc,
                    ch6_name: cfg.ch6_desc,
                    ch7_name: cfg.ch7_desc,
                    ch8_name: cfg.ch8_desc,
                    ch9_name: cfg.ch9_desc,
                    ch10_name: cfg.ch10_desc,
                    uom1: cfg.uom1,
                    uom2: cfg.uom2,
                    uom3: cfg.uom3,
                    uom4: cfg.uom4,
                    uom5: cfg.uom5,
                    uom6: cfg.uom6,
                    uom7: cfg.uom7,
                    uom8: cfg.uom8,
                    uom9: cfg.uom9,
                    uom10: cfg.uom10
                }
            )
                },
                success: function (jsondata) {
                    oncomplete(jsondata[0]);
                },
                error: function (jqxhr, textStatus) {
                    alert("Ajax request UpdateChannelConfig failed with error: " + jqxhr.statusText);
                }
            });
        }
        catch (error) {
            alert(error);
        }


    }
    catch (e) {
        OnError("Error in UpdateConfig ", e);
    }
}





BaseViewModel.prototype.InsertChannelConfig = function (cfg, oncomplete) {
    try {
        var self = this;
        var murl = self.UrlBase() + 'olmconfig';

        try {
            $.ajax({
                dataType: self.MJSONDataType(),
                url: murl,
                data: { MethodName: 'InsertChannelConfiguration',
                    Parameters: ko.toJSON(
                {
                    ch_grp_hdr_id: cfg.ch_grp_hdr_id,
                    entry_by_name: cfg.entry_by_name,
                    ch_grp_hdr_desc: cfg.ch_grp_hdr_desc,
                    ch1_name: cfg.ch1_desc,
                    ch2_name: cfg.ch2_desc,
                    ch3_name: cfg.ch3_desc,
                    ch4_name: cfg.ch4_desc,
                    ch5_name: cfg.ch5_desc,
                    ch6_name: cfg.ch6_desc,
                    ch7_name: cfg.ch7_desc,
                    ch8_name: cfg.ch8_desc,
                    ch9_name: cfg.ch9_desc,
                    ch10_name: cfg.ch10_desc,
                    uom1: cfg.uom1,
                    uom2: cfg.uom2,
                    uom3: cfg.uom3,
                    uom4: cfg.uom4,
                    uom5: cfg.uom5,
                    uom6: cfg.uom6,
                    uom7: cfg.uom7,
                    uom8: cfg.uom8,
                    uom9: cfg.uom9,
                    uom10: cfg.uom10
                }
            )
                },
                success: function (jsondata) {
                    oncomplete(jsondata[0]);
                },
                error: function (jqxhr, textStatus) {
                    alert("Ajax request UpdateChannelConfig failed with error: " + jqxhr.statusText);
                }
            });
        }
        catch (error) {
            alert(error);
        }


    }
    catch (e) {
        OnError("Error in UpdateConfig ", e);
    }
}


BaseViewModel.prototype.UpdateConfig = function (cfg, oncomplete) {
    try {
        var self = this;
        var murl = self.UrlBase() + 'olmconfig';

        try {
            $.ajax({
                dataType: self.MJSONDataType(),
                url: murl,
                data: { MethodName: 'UpdateConfiguration',
                    Parameters: ko.toJSON(
                {
                    OlmCfgID: cfg.olm_cfg_id,
                    entry_by_name: cfg.entry_by_name,
                    comm_id: cfg.comm_id,
                    cfg_grp_id: cfg.cfg_grp_id,
                    base_hdr_id: cfg.base_hdr_id,
                    ch_grp_hdr_id: cfg.ch_grp_hdr_id,
                    ev_cfg_hdr_id: cfg.ev_cfg_hdr_id,
                    vrt_chs_hdr_id: cfg.vrt_chs_hdr_id,
                    cfg_desc: cfg.cfg_desc
                }
            )
                },
                success: function (jsondata) {
                    oncomplete(jsondata[0]);
                },
                error: function (jqxhr, textStatus) {
                    alert("Ajax request UpdateConfig failed with error: " + jqxhr.statusText);
                }
            });
        }
        catch (error) {
            alert(error);
        }


    }
    catch (e) {
        OnError("Error in UpdateConfig ", e);
    }
}

BaseViewModel.prototype.GetAllVirtualConfigurations = function (oncomplete) {
    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            timeout: 53000,
            data: { MethodName: 'GetAllVirtualConfigurations', Parameters: ko.toJSON({}) },
            success: function (jsondata) {
                oncomplete(jsondata);
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetAllVirtualConfigurations failed with error: " + textStatus);
            }
        });
    }
    catch (error) {
        alert(error);
    }

}
BaseViewModel.prototype.GetAllConfigurationGroups = function (oncomplete) {

    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            timeout: 53000,
            data: { MethodName: 'GetAllConfigurationGroups', Parameters: ko.toJSON({}) },
            success: function (jsondata) {
                oncomplete(jsondata);
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetAllConfigurationGroups failed with error: " + textStatus);
            }
        });
    }
    catch (error) {
        alert(error);
    }

}
//

BaseViewModel.prototype.GetAllConfigurations = function (oncomplete) {

    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            timeout: 53000,
            data: { MethodName: 'GetAllConfigurations', Parameters: ko.toJSON({}) },
            success: function (jsondata) {
                oncomplete(jsondata);
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetAllConfigurations failed with error: " + jqxhr.statusText);
            }
        });
    }
    catch (error) {
        BaseViewModel.prototype.BaseErrorHandler(error);
    }

}
BaseViewModel.prototype.GetConfigurations = function (group_name, sub_name, system_voltage_val, loc_name, equipment, manu_name, model_num, mech_val, mech_op_val, tstampStart, tstampEnd, callback, mssg) {
    if (mssg != undefined) {
        alert(mssg);
    }
    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    //var murl = "json/GetConfigurations.json"; //self.UrlBase() + 'olmconfig'
    //alert(murl);
    //alert(group_name + ',' + sub_name + ',' + loc_name);
    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            timeout: 53000,
            data: { MethodName: 'GetConfigurations', Parameters: ko.toJSON({ GroupName: group_name, SubName: sub_name, SystemVoltage: system_voltage_val, LocName: loc_name, ManuName: manu_name, ModelNumber: model_num, MechValue: mech_val, MechOpValue: mech_op_val, Equipment: equipment }) },
            success: function (jsondata) {
                if (callback != undefined) {
                    callback(jsondata);
                }
                else {
                    alert("GetConfigurations callback function undefined");
                }
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetConfigurations failed with error: " + jqxhr.statusText);
                callback();
            }
        });
    }
    catch (error) {
        self.BaseErrorHandler(e);
    }

}

BaseViewModel.prototype.GetManufacturers = function () {

    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    //alert(murl);
    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            data: { MethodName: 'GetManufacturers', Parameters: ko.toJSON({}) },
            success: function (jsondata) {
                jsondata.reverse();
                jsondata.push('Select manufacturer');
                jsondata.reverse();
                self.Manufacturers(jsondata);
                self.SelectedManufacturer('Select manufacturer');
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetManufacturers failed with error: " + jqxhr.statusText);
            }
        });
    }
    catch (error) {
        self.BaseErrorHandler(e);
    }
}



//
BaseViewModel.prototype.GetCfgConfigurationGroups = function (oncomplete) {

    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            timeout: 53000,
            data: { MethodName: 'GetAllConfigurationGroups', Parameters: ko.toJSON({}) },
            success: function (jsondata) {
                oncomplete(jsondata);
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetCfgGroupConfigurations failed with error: " + textStatus);
            }
        });
    }
    catch (error) {
        alert(error);
    }

}

BaseViewModel.prototype.GetAllCommConfigurations = function (oncomplete) {

    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            timeout: 53000,
            data: { MethodName: 'GetAllCommConfigurations', Parameters: ko.toJSON({}) },
            success: function (jsondata) {
                oncomplete(jsondata);
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetAllCommConfigurations failed with error: " + textStatus);
            }
        });
    }
    catch (error) {
        alert(error);
    }

}

BaseViewModel.prototype.GetAllChannelConfigurations = function (oncomplete) {

    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            timeout: 53000,
            data: { MethodName: 'GetAllChannelConfigurations', Parameters: ko.toJSON({}) },
            success: function (jsondata) {
                oncomplete(jsondata);
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetAllChannelConfigurations failed with error: " + jqhxr);
            }
        });
    }
    catch (error) {
        alert("Ajax request GetAllChannelConfigurations failed " + error);
    }

}

BaseViewModel.prototype.GetAllChannelHeaderConfigurations = function (oncomplete) {

    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            timeout: 53000,
            data: { MethodName: 'GetAllChannelHeaderConfigurations', Parameters: ko.toJSON({}) },
            success: function (jsondata) {
                oncomplete(jsondata);
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetAllChannelHeaderConfigurations failed with error: " + textStatus);
            }
        });
    }
    catch (error) {
        alert(error);
    }

}

BaseViewModel.prototype.GetAllEVHeaderConfigurations = function (oncomplete) {

    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            timeout: 53000,
            data: { MethodName: 'GetEventConfigs', Parameters: ko.toJSON({}) },
            success: function (jsondata) {
                oncomplete(jsondata);
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetAllEVHeaderConfigurations failed with error: " + textStatus);
            }
        });
    }
    catch (error) {
        alert(error);
    }

}

BaseViewModel.prototype.GetAllBaseHeaderConfigurations = function (oncomplete) {

    var self = this;
    var murl = self.UrlBase() + 'olmconfig';
    try {
        $.ajax({
            dataType: self.MJSONDataType(),
            url: murl,
            timeout: 53000,
            data: { MethodName: 'GetAllBaseHeaderConfigurations', Parameters: ko.toJSON({}) },
            success: function (jsondata) {
                oncomplete(jsondata);
            },
            error: function (jqxhr, textStatus) {
                alert("Ajax request GetAllBaseHeaderConfigurations failed with error: " + textStatus);
            }
        });
    }
    catch (error) {
        alert(error);
    }

}

BaseViewModel.prototype.GetMemoryConfig = function (oncomplete) {

    var self = this;
    var murl = self.UrlBase() + 'olmconfig'; //"webapi/api/notesmanagement";
    try {
        $.ajax({
            dataType: self.MJSONDataType(), //"json",
            url: murl,
            data: { MethodName: 'GetMemoryConfigurations', Parameters: ko.toJSON({}) },
            success: function (jsondata) {

                oncomplete(jsondata);
            }
        });
    }
    catch (error) {
        alert(error);
    }
}

